module Adparlor
  module Facebook
    module GraphApi
      class Ad < GraphObject
        include Fields::Ad
        include Traits::Methods
        field_attrs FIELDS
        allow_method :create
        allow_local_method :create, :update, :destroy

        def path
          raise FbError.new('required parameter account_id missing', 500) unless account_id
          "/act_#{account_id}/ads"
        end

        def update_path
          raise FbError.new('required parameter id missing', 500) unless id
          "/#{id}"
        end

        def adcreatives
          @adcreatives ||= CollectionProxy.new AdCreative, "/#{id}/adcreatives", access_token
        end

        def leads
          @leads ||= CollectionProxy.new UserLeadGenInfo, "/#{id}/leads", access_token
        end

        def previews
          @previews ||= CollectionProxy.new(AdPreview, "/#{id}/previews", access_token)
        end

        def reachestimate
          @reachestimate ||= CollectionProxy.new ReachEstimate, "/#{id}/reachestimate", access_token
        end

        def targetingsentencelines
          @targetingsentencelines ||= CollectionProxy.new TargetingSentenceLine, "/#{id}/targetingsentencelines", access_token
        end
      end
    end
  end
end
