module Adparlor
  module Facebook
    module GraphApi
      class AdsPixelStat < GraphObject
        include Fields::AdsPixelStat
        include Traits::Methods
        field_attrs FIELDS

        def get(path, options)
          validate_options(options)
          super(path, options)
        end

        private

        def validate_options(options)
          options.delete(:fields) # just not required for this request so ignore them if they are passed
          raise FbError.new('invalid parameters passed', 500) if
            (options.keys.map(&:to_s) - %w(access_token aggregation end_time event start_time id)).any?
          raise FbError.new('required parameter aggregation missing', 500) if options[:aggregation].nil?
        end
      end
    end
  end
end
