module Adparlor
  module Facebook
    module GraphApi
      class CustomAudience < GraphObject
        include Fields::CustomAudience
        include Traits::Methods
        field_attrs FIELDS
        allow_method :create, :destroy
        allow_local_method :create, :destroy, :update

        def path
          raise FbError.new('required parameter account_id missing', 500) unless account_id
          "/act_#{account_id}/customaudiences"
        end

        def update_path
          raise FbError.new('required parameter id missing', 500) unless id
          "/#{id}"
        end

        def adaccounts
          @adaccounts ||= CollectionProxy.new(AdAccount, "/#{id}/adaccounts", access_token)
        end

        def users
          @users ||= CollectionProxy.new CustomAudienceUser, "#{id}/users", access_token
        end
      end
    end
  end
end
