module Adparlor
  module Facebook
    module GraphApi
      class PageAndPlace < GraphObject
        include Fields::PageAndPlace
        include Traits::Methods
        field_attrs FIELDS

        def promotable_posts
          @promotable_posts ||= CollectionProxy.new(Post, "/#{id}/promotable_posts", access_token)
        end

        def ads_posts
          @ads_posts ||= CollectionProxy.new Post, "/#{id}/ads_posts", access_token, nil, include_inline_create: true
        end

        def picture
          @picture ||= CollectionProxy.new(Picture, "/#{id}/picture", access_token)
        end

        def page_backed_instagram_accounts
          @page_backed_instagram_accounts ||= CollectionProxy.new(InstagramAccount, "/#{id}/page_backed_instagram_accounts", access_token)
        end

        def leadgen_forms
          @leadgen_forms ||= CollectionProxy.new(LeadgenForm, "/#{id}/leadgen_forms", access_token)
        end
      end
    end
  end
end
