module Adparlor
  module Facebook
    module GraphApi
      class ProductCatalog < GraphObject
        include Fields::ProductCatalog
        include Traits::Methods
        field_attrs FIELDS

        def product_items
          @product_items ||= CollectionProxy.new ProductItem, "/#{id}/products", access_token
        end

        def product_feeds
          @product_feeds ||= CollectionProxy.new ProductFeed, "/#{id}/product_feeds", access_token
        end

        def product_groups
          @product_groups ||= CollectionProxy.new ProductGroup, "/#{id}/product_groups", access_token
        end

        def product_sets
          @product_sets ||= CollectionProxy.new ProductSet, "/#{id}/product_sets", access_token
        end
      end
    end
  end
end
