module Adparlor
  module Facebook
    module GraphApi
      class ProductSet < GraphObject
        include Fields::ProductSet
        include Traits::Methods
        field_attrs FIELDS
        allow_local_method :create, :destroy, :update

        def path
          raise FbError.new('required parameter product_catalog_id missing', 500) unless @product_catalog_id
          "/#{@product_catalog_id}/product_sets"
        end

        def update_path
          raise FbError.new('required parameter id missing', 500) unless @id
          "/#{@id}"
        end

        def products
          @product_items ||= CollectionProxy.new ProductItem, "/#{id}/products", access_token
        end
      end
    end
  end
end
